C     $Id: trcomm.inc,v 1.46 2006/03/25 03:27:43 honda Exp $
C
      INCLUDE '../tr/trcom0.inc'
C
C     ****** CONSTANTS ******
C
      COMMON /TRCNS1/ PI,AME,AMM,AEE,VC,RMU0,EPS0,RKEV
C
C     ****** PARAMETERS ******
C
      COMMON /TRPRM1/ RR,RA,RKAP,RDLT,BB,RIPS,RIPE,RIPSS,PHIA
      COMMON /TRPRM2/ PA(NSTM),PZ(NSTM),PN(NSTM),PNS(NSTM),
     &                PT(NSTM),PTS(NSTM)
      COMMON /TRPRM3/ PNC,PNFE,PNNU,PNNUS
      COMMON /TRPRM4/ PROFN1,PROFN2,PROFT1,PROFT2,PROFU1,PROFU2
      COMMON /TRPRM5/ PROFJ1,PROFJ2,ALP(3)
      COMMON /TRPRM6/ AD0,AV0,CNP,CNH,CDP,CDH,CNN,CDW(8),CWEB,
     &                MDLKAI,MDLETA,MDLAD,MDLAVK,MDLKNC,MDLTPF
      COMMON /TRPRM7/ DT,NRMAX,NTMAX,NTSTEP,NGTSTP,NGRSTP,NGPST,TSST
      COMMON /TRPRM8/ EPSLTR,LMAXTR
      COMMON /TRPRM9/ CHP,CK0,CK1,CKALFA,CKBETA,CKGUMA,CNB,CALF,CSPRS
      COMMON /TRPRF1/ MODELG,MDLDSK,MDTC
C
C     ****** MODEL PARAMETERS ******
C
      COMMON /TRMDL1/ TPRST,MDLST,MDLNF,IZERO
      COMMON /TRMDL2/ PNBTOT,PNBR0,PNBRW,PNBVY,PNBVW,PNBENG,PNBRTG,
     &                MDLNB
      COMMON /TRMDL3/ PECTOT,PECR0,PECRW,PECTOE,PECNPR,MDLEC
      COMMON /TRMDL4/ PLHTOT,PLHR0,PLHRW,PLHTOE,PLHNPR,MDLLH
      COMMON /TRMDL5/ PICTOT,PICR0,PICRW,PICTOE,PICNPR,MDLIC
      COMMON /TRMDL6/ PNBCD,PECCD,PLHCD,PICCD,PBSCD,MDLCD
      COMMON /TRMDL7/ PELTOT,PELR0,PELRW,PELRAD,PELVEL
      COMMON /TRMDL8/ PELTIM,PELPAT(NSTM),MDLPEL,MDLJBS
C
C     ****** CONTROL VARIABLES ******
C
      COMMON /TRCTL1/ T,TST,TPRE,WPPRE,RIP,NT
      COMMON /TRCTL2/ DR,FKAP,PNSS(NSTM),RHOA,NRAMAX,NROMAX,RIPA,NREDGE
      COMMON /TRCTL3/ VSEC
      COMMON /TRCTL4/ GTCPU1
      COMMON /TRCTL5/ NTMAX_SAVE
      COMMON /TRCTL6/ IREAD
C
C     ****** MATRIX VARIBALES ******
C
      COMMON /TRMTX1/ XV(NVM,NRM),YV(NFM,NRM),ZV(NSM,NRM)
      COMMON /TRMTX2/ AX(LDAB,MLM),X(MLM),AY(NFM,NRM),Y(NFM,NRM)
      COMMON /TRMTX3/ AZ(NSM,NRM),Z(NSM,NRM)
C     
C     ****** FUNDAMENTAL VARIABLES ******
C
      COMMON /TRVAR1/ RG(NRM),RM(NRM),RHOM(NRM),RHOG(NRM)
      COMMON /TRVAR2/ RN(NRM,NSTM),RT(NRM,NSTM),RU(NRM,NSTM)
      COMMON /TRVAR3/ RW(NRM,NFM),BP(NRM),RDP(NRM),RPSI(NRM)
C
C     ****** PROFILE VARIABLES ******
C
      COMMON /TRPFL1/ RNF(NRM,NFM),RTF(NRM,NFM)
      COMMON /TRPFL2/ ANC(NRM),ANFE(NRM),ANNU(NRM)
      COMMON /TRPFL3/ ZEFF(NRM),PZC(NRM),PZFE(NRM)
      COMMON /TRPFL4/ BETA(NRM),BETAP(NRM)
      COMMON /TRPFL5/ BETAL(NRM),BETAPL(NRM),BETAQ(NRM)
      COMMON /TRPFL6/ PBM(NRM),PADD(NRM)
      COMMON /TRPFL7/ VTOR(NRM),VPAR(NRM),VPRP(NRM),VPOL(NRM),WROT(NRM)
      COMMON /TRPFL8/ ER(NRM),VEXB(NRM)
      COMMON /TRPFL8/ WEXB(NRM),AGMP(NRM)
C
C     ****** SOURCE VARIABLES ******
C
      COMMON /TRSRC1/ PIN(NRM,NSTM),SSIN(NRM,NSTM)
      COMMON /TRSRC2/ AJ(NRM),AJOH(NRM),EZOH(NRM),QP(NRM),AJTOR(NRM)
      COMMON /TRSRC3/ AJNB(NRM),AJRF(NRM),AJBS(NRM)
      COMMON /TRSRC4/ PNB(NRM),SNB(NRM),PBIN(NRM),PBCL(NRM,NSTM),RTG(10)
      COMMON /TRSRC5/ PNF(NRM),SNF(NRM),PFIN(NRM),PFCL(NRM,NSTM)
      COMMON /TRSRC6/ POH(NRM),PRF(NRM,NSTM),SPE(NRM,NSTM)
      COMMON /TRSRC7/ PRL(NRM),PCX(NRM),PIE(NRM),SIE(NRM),SCX(NRM),
     &                TSIE(NRM),TSCX(NRM)
      COMMON /TRSRC8/ PRFV(NRM,NSTM,3),AJRFV(NRM,3)
      COMMON /TRSRC9/ RGFLX(NRM,NSM)
C
C     ****** COEFFICIENT VARIABLES ******
C
      COMMON /TRCEF1/ ETA(NRM),SALPHA(NRM)
      COMMON /TRCEF2/ AK(NRM,NSTM),AVK(NRM,NSTM),AD(NRM,NSTM),
     &                AV(NRM,NSTM)
      COMMON /TRCEF3/ AKNC(NRM,NSTM),AKDW(NRM,NSTM)
      COMMON /TRCEF4/ ADNC(NRM,NSTM),ADDW(NRM,NSTM)
      COMMON /TRCEF5/ AVNC(NRM,NSTM),AVDW(NRM,NSTM)
      COMMON /TRCEF6/ AVKNC(NRM,NSTM),AVKDW(NRM,NSTM)
      COMMON /TRCEF7/ TAUB(NRM),TAUF(NRM),TAUK(NRM)
      COMMON /TRCEF8/ VGR1(NRM,4),VGR2(NRM,4),VGR3(NRM,4),VGR4(NRM,4)
      COMMON /TRCEF9/ KGR1,KGR2,KGR3,KGR4
      CHARACTER KGR1*40,KGR2*40,KGR3*40,KGR4*60
C
C     ****** GLOBAL VARIABLES ******
C
      COMMON /TRGLB1/ ANS0(NSTM),TS0(NSTM),ANSAV(NSTM),ANLAV(NSTM),
     &                TSAV(NSTM),WST(NSTM)
      COMMON /TRGLB2/ ANF0(NFM),TF0(NFM),ANFAV(NFM),TFAV(NFM),WFT(NFM)
      COMMON /TRGLB3/ WBULKT,WTAILT,WPT
      COMMON /TRGLB4/ AJT,AJOHT,AJNBT,AJRFT,AJBST,AJRFVT(3),AJTTOR
      COMMON /TRGLB5/ PINT,POHT,PNBT,PRFT(NSTM),PNFT,PRFVT(NSTM,3)
      COMMON /TRGLB6/ PBINT,PBCLT(NSTM),PFINT,PFCLT(NSTM)
      COMMON /TRGLB7/ POUT,PCXT,PIET,PRLT,PLT(NSTM),PEXST,PRFST
      COMMON /TRGLB8/ SINT,SIET,SNBT,SNFT,SPET(NSTM),SOUT,SLT(NSTM)
      COMMON /TRGLB9/ VLOOP,ALI,RQ1,RPE,Q0,ZEFF0,QF
      COMMON /TRGLBA/ WPDOT,TAUE1,TAUE2,TAUE89,TAUE98,H98Y2
      COMMON /TRGLBB/ BETAP0,BETAPA,BETA0,BETAA,BETAQ0,BETAN
C
C     ****** GRAPHIC DATA VARIABLES ******
C
      COMMON /TRPLR1/ GVR(NRMP,NGM,NCGM),GRM(NRM),GRG(NRMP),GTR(NGM),NGR
      COMMON /TRPLT1/ GVT(NTM,NCTM),GT(NTM),GTS(NTM),NGT,NGST
      COMMON /TRPLG1/ GYR(NRMP,8),GYT(NTM,8),GER(NRMP,8)
      COMMON /TRPLD1/ G3D(NRM,NGM,NCTM)
      COMMON /TRPLC1/ GJB(NRMP,4),GET(NRMP,5),GAD(NRMP,4),GAK(NRMP,6)
      COMMON /TRPLN1/ GPNB(4*NRM,10)
      COMMON /TRPLN2/ GBL(NLM),GBR(NLM,10),GBRH(NLM,10),GBP1(NLM,10),
     &                GBAN(NLM,10),NLMAX(10)
C
C     ****** EQUILIBRIUM INTERFACE VARIABLES ******
C
      COMMON /TREQV1/ RHOTR(NRM)
      COMMON /TREQV2/ PRHO(NRM),HJRHO(NRM),VTRHO(NRM),TRHO(NRM)
      COMMON /TREQV3/ QRHO(NRMP),TTRHO(NRM),DVRHO(NRM),RKPRHO(NRM)
      COMMON /TREQV4/ ABRHO(NRM),ARRHO(NRM)
      COMMON /TREQV5/ AR1RHO(NRM),AR2RHO(NRM),RJCB(NRM)
      COMMON /TREQV6/ EPSRHO(NRM),BPRHO(NRM)
      COMMON /TREQV7/ RMJRHO(NRM),RMNRHO(NRM)
      COMMON /TREQV8/ TTRHOG(NRM),DVRHOG(NRM),RKPRHOG(NRM)
      COMMON /TREQV9/ ABRHOG(NRM),ARRHOG(NRM)
      COMMON /TREQVA/ AR1RHOG(NRM),AR2RHOG(NRM)
      COMMON /TREQVB/ ABB2RHOG(NRM),AIB2RHOG(NRM),ARHBRHOG(NRM)
      COMMON /TREQVC/ RMJRHOG(NRM),RMNRHOG(NRM)
      COMMON /TREQVD/ BPSEQ,RIPEQ,FACTQ(NRM)
C
C     ****** LOG FILE NAME ******
C
      COMMON /TRNAM1/ KNAMEQ,KNAMTR,KFNLOG
      CHARACTER KNAMEQ*80,KNAMTR*80,KFNLOG*80
C
C     ****** ADDITIONAL PART BY HONDA MITSURU ******
C
      COMMON /TRADD1/ VV(NVM,NVM,4,3),DD(NVM,NVM,4,3)
      COMMON /TRADD2/ VI(NVM,NVM,2,3),DI(NVM,NVM,2,3)
      COMMON /TRADD3/ FA(3,3),FB(3,3),FC(3,3)
      COMMON /TRADD4/ RTM(NSTM),AMZ(NSTM)
      COMMON /TRADD5/ PEX(NRM,NSTM),PEXT(NSTM),SEX(NRM,NSTM)
      COMMON /TRADD6/ NTEQIT
      COMMON /TRADD7/ PNSSA(NSTM),PNSA(NSTM),PTSA(NSTM)
      COMMON /TRADD8/ VOID
      COMMON /TRADD9/ AKDWD(NRM,NSM,NSM),AKDWP(NRM,NSM,NSM)
      COMMON /TRADDA/ ADDWD(NRM,NSM,NSM),ADDWP(NRM,NSM,NSM)
C
C     ****** MODEL SELECTION VARIABLES ******
C
      COMMON /TRMDS1/ NSS(NEQM),NSV(NEQM),NNS(NEQM),NST(NEQM)
      COMMON /TRMDS2/ NEQMAX
      COMMON /TRMDS3/ MDLEQB,MDLEQN,MDLEQT,MDLEQU,MDLEQZ,MDLEQ0,MDLEQE,
     &                MDLEOI
      COMMON /TRMDS4/ NSMAX,NSZMAX,NSNMAX,NSCMAX,NSTMAX
      COMMON /TRMDS5/ MDLWLD,MDDIAG,MDDW,MDLFLX,MDLER,MDCD05,MDEDGE
      COMMON /TRMDS6/ SUMPBM
C
C     ****** NCLASS ******
C
      COMMON /TRNCL1/ MDNCLS,             NSLMAX
      COMMON /TRNCL2/ AJBSNC(NRM),        ETANC(NRM),        AJEXNC(NRM)
      COMMON /TRNCL3/ CJBSP(NRM,NSM),     CJBST(NRM,NSM)
      COMMON /TRNCL4/ AKNCP(NRM,NSM,NSM), AKNCT(NRM,NSM,NSM)
      COMMON /TRNCL5/ ADNCP(NRM,NSM,NSM), ADNCT(NRM,NSM,NSM)
      COMMON /TRNCL6/ RGFLS(NRM,5,NSM),   RQFLS(NRM,5,NSM)
      COMMON /TRNCL7/ ADNCG(NRM,NSM),     AVNCG(NRM,NSM)
      COMMON /TRNCL8/ AKLP(NRM,NSM,NSM),  AKLD(NRM,NSM,NSM)
      COMMON /TRNCL9/ ADLP(NRM,NSM,NSM),  ADLD(NRM,NSM,NSM)
C
C     ****** STORED VARIABLES FOR UFILE ******
C
      COMMON /TRSVU1/ QPU(NTUM,NRMP),     RNU(NTUM,NRMP,NSM),
     &                RTU(NTUM,NRMP,NSM), AJU(NTUM,NRMP),
     &                AJNBU(NTUM,NRMP),   BPU(NTUM,NRMP)
      COMMON /TRSVU2/ PNBU(NTUM,NRMP,NSM),PICU(NTUM,NRMP,NSM),
     &                PRLU(NTUM,NRMP),    PECU(NTUM,NRMP),
     &                POHU(NTUM,NRMP)
      COMMON /TRSVU3/ DVRHOU(NTUM,NRMP)
      COMMON /TRSVU4/ RKPRHOU(NTUM,NRMP), RMJRHOU(NTUM,NRMP),
     &	              RMNRHOU(NTUM,NRMP)
      COMMON /TRSVU5/ ARRHOU(NTUM,NRMP),  AR1RHOU(NTUM,NRMP),
     &                AR2RHOU(NTUM,NRMP)
      COMMON /TRSVU6/ ABRHOU(NTUM,NRMP),  TTRHOU(NTUM,NRMP)
      COMMON /TRSVU7/ PTSU(NTUM,NSTM),    PNSU(NTUM,NSTM),
     &                PTSUA(NTUM,NSTM),   PNSUA(NTUM,NSTM),
     &                PNFU(NTUM),         PNFUA(NTUM)
      COMMON /TRSVU8/ SNBU(NTUM,NRMP,NSM),SWLU(NTUM,NRMP)
      COMMON /TRSVU9/ RRU(NTUM),RAU(NTUM),PHIAU(NTUM),VOLAU(NTUM)
      COMMON /TRSVUA/ RIPU(NTUM),BBU(NTUM),RKAPU(NTUM),PNBIU(NTUM)
      COMMON /TRSVUB/ AJBSU(NTUM,NRMP),   ZEFFU(NTUM,NRMP)
      COMMON /TRSVUC/ PBMU(NTUM,NRMP),    RNFU(NTUM,NRMP)
      COMMON /TRSVUD/ WROTU(NTUM,NRMP)
      COMMON /TRSVUE/ RNU_ORG(NTUM,NRMP,NSM),ZEFFU_ORG(NTUM,NRMP)
C
C     ****** UFILE CONTROL ******
C
      CHARACTER KUFDEV*80,KUFDCG*80
      COMMON /TRUFL1/ KUFDEV,KUFDCG
      COMMON /TRUFL2/ MDLXP,MDLUF
      COMMON /TRUFL3/ MODEP,MDNI,MDCURT,MDNM1,MDLJQ,MDPHIA
      COMMON /TRUFL4/ TIME_INT,NTS
C
C     ****** LAPACK ******
C
      COMMON /TRLPCK/ MDLPCK

