C     $Id: eqsplf.f,v 1.8 2005/08/26 12:47:38 fukuyama Exp $
C
C     ***** INTERPOLATE FUNCTIONS *****
C
      FUNCTION FNPSIN(RHON)
C
      INCLUDE '../eq/eqcomq.inc'
C
      PSITL=PSITA*RHON*RHON
      CALL SPL1DF(PSITL,PSIPL,PSIT,UPSIP,NRMAX,IERR)
      IF(IERR.NE.0) WRITE(6,*) 'XX FNPSIN: SPL1DF ERROR : IERR=',IERR
      FNPSIN=PSIPL/PSIPA
      RETURN
      END
C
      FUNCTION FNRHON(PSIN)
C
      INCLUDE '../eq/eqcomq.inc'
C
      PSIPL=PSIPA*PSIN
      CALL SPL1DF(PSIPL,PSITL,PSIP,UPSIT,NRMAX,IERR)
      IF(IERR.NE.0) WRITE(6,*) 'XX FNRHON: SPL1DF ERROR : IERR=',IERR
      IF(PSITL.LE.0.D0) THEN
         FNRHON=0.D0
      ELSE
         FNRHON=SQRT(PSITL/PSITA)
      ENDIF
      RETURN
      END
C
      FUNCTION FNPSIP(RHON)
C
      INCLUDE '../eq/eqcomq.inc'
C
      PSITL=PSITA*RHON*RHON
      CALL SPL1DF(PSITL,PSIPL,PSIT,UPSIP,NRMAX,IERR)
      IF(IERR.NE.0) WRITE(6,*) 'XX FNPSIN: SPL1DF ERROR : IERR=',IERR
      FNPSIP=PSIPL
      RETURN
      END
C
      FUNCTION FNDPSIP(RHON)
C
      INCLUDE '../eq/eqcomq.inc'
C
      PSITL=PSITA*RHON*RHON
      CALL SPL1DD(PSITL,PSIPL,DPSIPL,PSIT,UPSIP,NRMAX,IERR)
      IF(IERR.NE.0) WRITE(6,*) 'XX FNPSIN: SPL1DF ERROR : IERR=',IERR
      FNDPSIP=2.D0*PSITA*RHON*DPSIPL
      RETURN
      END
C
      FUNCTION FNPSIT(RHON)
C
      INCLUDE '../eq/eqcomq.inc'
C
      FNPSIT=PSITA*RHON*RHON
      RETURN
      END
C
      FUNCTION FNPPS(RHON)
C
      INCLUDE '../eq/eqcomq.inc'
C
      RHOTL=RHON
      CALL SPL1DF(RHOTL,PPL,RHOT,UPPS,NRMAX,IERR)
      IF(IERR.NE.0) WRITE(6,*) 'XX FNPPS: SPL1DF ERROR : IERR=',IERR
      FNPPS=PPL
      RETURN
      END
C
      FUNCTION FNTTS(RHON)
C
      INCLUDE '../eq/eqcomq.inc'
C
      RHOTL=RHON
      CALL SPL1DF(RHOTL,TTL,RHOT,UTTS,NRMAX,IERR)
      IF(IERR.NE.0) WRITE(6,*) 'XX FNTTS: SPL1DF ERROR : IERR=',IERR
      FNTTS=TTL
      RETURN
      END
C
      FUNCTION FNQPS(RHON)
C
      INCLUDE '../eq/eqcomq.inc'
C
      RHOTL=RHON
      CALL SPL1DF(RHOTL,QPL,RHOT,UQPS,NRMAX,IERR)
      IF(IERR.NE.0) WRITE(6,*) 'XX FNQPS: SPL1DF ERROR : IERR=',IERR
      FNQPS=QPL
      RETURN
      END
C
      FUNCTION FNVPS(RHON)
C
      INCLUDE '../eq/eqcomq.inc'
C
      RHOTL=RHON
      CALL SPL1DF(RHOTL,VPL,RHOT,UVPS,NRMAX,IERR)
      IF(IERR.NE.0) WRITE(6,*) 'XX FNVPS: SPL1DF ERROR : IERR=',IERR
      FNVPS=VPL
      RETURN
      END
C
      FUNCTION FNSPS(RHON)
C
      INCLUDE '../eq/eqcomq.inc'
C
      RHOTL=RHON
      CALL SPL1DF(RHOTL,SPL,RHOT,USPS,NRMAX,IERR)
      IF(IERR.NE.0) WRITE(6,*) 'XX FNSPS: SPL1DF ERROR : IERR=',IERR
      FNSPS=SPL
      RETURN
      END
C
      FUNCTION FNRLEN(RHON)
C
      INCLUDE '../eq/eqcomq.inc'
C
      RHOTL=RHON
      CALL SPL1DF(RHOTL,RLENL,RHOT,URLEN,NRMAX,IERR)
      IF(IERR.NE.0) WRITE(6,*) 'XX FNRLEN: SPL1DF ERROR : IERR=',IERR
      FNRLEN=RLENL
      RETURN
      END
C
      FUNCTION FNRRMN(RHON)
C
      INCLUDE '../eq/eqcomq.inc'
C
      RHOTL=RHON
      CALL SPL1DF(RHOTL,RRMINL,RHOT,URRMIN,NRMAX,IERR)
      IF(IERR.NE.0) WRITE(6,*) 'XX FNRRMN: SPL1DF ERROR : IERR=',IERR
      FNRRMN=RRMINL
      RETURN
      END
C
      FUNCTION FNRRMX(RHON)
C
      INCLUDE '../eq/eqcomq.inc'
C
      RHOTL=RHON
      CALL SPL1DF(RHOTL,RRMAXL,RHOT,URRMAX,NRMAX,IERR)
      IF(IERR.NE.0) WRITE(6,*) 'XX FNRRMX: SPL1DF ERROR : IERR=',IERR
      FNRRMX=RRMAXL
      RETURN
      END
C
      FUNCTION FNBBMN(RHON)
C
      INCLUDE '../eq/eqcomq.inc'
C
      RHOTL=RHON
      CALL SPL1DF(RHOTL,BBMINL,RHOT,UBBMIN,NRMAX,IERR)
      IF(IERR.NE.0) WRITE(6,*) 'XX FNBBMN: SPL1DF ERROR : IERR=',IERR
      FNBBMN=BBMINL
      RETURN
      END
C
      FUNCTION FNBBMX(RHON)
C
      INCLUDE '../eq/eqcomq.inc'
C
      RHOTL=RHON
      CALL SPL1DF(RHOTL,BBMAXL,PSIP,UBBMAX,NRMAX,IERR)
      IF(IERR.NE.0) WRITE(6,*) 'XX FNBBMX: SPL1DF ERROR : IERR=',IERR
      FNBBMX=BBMAXL
      RETURN
      END
